#ifndef _SUPPORTED_COMMANDCLASSINCLUSIONCONTROLLER_H_
#define _SUPPORTED_COMMANDCLASSINCLUSIONCONTROLLER_H_


//States
typedef enum INCLUSION_CONTROLLER_FSM_STATES {
    ST_INCLUSIONCONTROLLER_IDLE = 0,
    ST_WAITING_INCLUSION_CONTROLLER_COMPLETE,
    ST_WAITING_NODE_INFOMATION,
    ST_WAITING_SO_BOOTSTRAPPING_COMPLETE,//can't receive complete from SIS
    ST_WAITING_SECURE_S2_BOOTSTRAPPING_COMPLETE, //Support s2, bootstrapping s2, else if support s0, bootstrapping s0
    ST_WAITING_SECURE_S0_BOOTSTRAPPING_COMPLETE,

    ST_WAITING_S0_CMD_SUPPORTED_REPORT,
    ST_WAITING_S2_ACCESS_CMD_SUPPORTED_REPORT,
    ST_WAITING_S2_AUTHENTICATED_CMD_SUPPORTED_REPORT,
    ST_WAITING_S2_UNAUTHENTICATED_CMD_SUPPORTED_REPORT,
    ST_WAITING_RECEIVE_COMPLETE_AFTER_BOOT_S0,//After Inclusion bootstrapping S0 finish, 
    //it send complete to SIS and waiting complete from SIS (after SIS interview device finish)
    ST_WAITING_INTERVIEW,
    //when my device is SIS role in network
    ST_SIS_WAITING_NODE_INFOMATION,
    ST_WAITING_SIS_BOOTSTRAP_S2_COMPLETE,
    ST_WAITING_SIS_INTERVIEW_DEVICE,
    ST_WAITING_INCLUSION_BOOTSTRAP_S0_COMPLETE,
    ST_SIS_WAITING_S0_CMD_SUPPORTED_REPORT,
    ST_WAITING_SIS_INTERVIEW_DEVICE_S0,
    ST_WAITING_PUSH_NOTIFY_S2_BOOTSTRAP,

} INCLUSION_CONTROLLER_FSM_STATES_T;

//Events
typedef enum INCLUSION_CONTROLLER_FSM_EV {
    EV_ADD_NODE_NORMAL_OK = 0,
    EV_NO_SIS_DEVICE,
    EV_RECEIVE_INCLUSION_CONTROLLER_INITIATE_S0,
    EV_RECEIVE_INCLUSION_CONTROLLER_COMPLETE_OK,
    EV_RECEIVE_INCLUSION_CONTROLLER_COMPLETE_NOT_OK,
    EV_RECEIVE_NODE_INFOMATION,
    EV_ADD_SO_SECURE_OK,
    EV_ADD_SO_SECURE_FAIL,
    EV_DEVICE_NOT_SUPPORT_S2,
    EV_MY_NODE_NOT_SUPPORT_THIS_SCHEME,
    EV_DEVICE_NOT_SUPPORT_S0,
    EV_ADD_S2_SECURE_OK,
    EV_ADD_S2_SECURE_FAIL,
    EV_INTERVIEW_DEVICE_OK,
    EV_TIMEOUT_INCLUSION_CONTROLLER_STATE,
    EV_RECEIVE_INCLUSION_CONTROLLER_INITIATE_PROXY,
    EV_RECEIVE_COMPLETE_OK_FROM_INCLUSION,
    EV_RECEIVE_COMPLETE_NOT_OK_FROM_INCLUSION,
    EV_CLOSE_INCLUSION_CONTROLLER,

} INCLUSION_CONTROLLER_FSM_EV_T;

void PostEventInclusionController(INCLUSION_CONTROLLER_FSM_EV_T event);

#endif /* _SUPPORTED_COMMANDCLASSINCLUSIONCONTROLLER_H_ */
